--- maildir-storage.c	2006-05-10 12:29:23.000000000 +0200
+++ maildir-storage.c_new	2006-05-10 12:30:19.000000000 +0200
@@ -81,23 +81,27 @@
 		/* <Maildir> [:INBOX=<dir>] [:INDEX=<dir>] [:CONTROL=<dir>] */
 		if (debug)
 			i_info("maildir: data=%s", data);
-		p = strchr(data, ':');
-		if (p == NULL)
-			root_dir = data;
-		else {
-			root_dir = t_strdup_until(data, p);
-
-			do {
-				p++;
-				if (strncmp(p, "INBOX=", 6) == 0)
-					inbox_dir = t_strcut(p+6, ':');
-				else if (strncmp(p, "INDEX=", 6) == 0)
-					index_dir = t_strcut(p+6, ':');
-				else if (strncmp(p, "CONTROL=", 8) == 0)
-					control_dir = t_strcut(p+8, ':');
-				p = strchr(p, ':');
-			} while (p != NULL);
-		}
+        /* extracting INBOX / INDEX / CONTROL suffices */
+        if (((p = strstr(data, ":INBOX=")) != NULL)
+            || ((p = strstr(data, ":INDEX=")) != NULL)
+            || ((p = strstr(data, ":CONTROL=")) != NULL)) {
+            root_dir = t_strdup_until(data, p);
+
+            do {
+                p++;
+                if (strncmp(p, "INBOX=", 6) == 0)
+                    inbox_dir = t_strcut(p+6, ':');
+                else if (strncmp(p, "INDEX=", 6) == 0)
+                    index_dir = t_strcut(p+6, ':');
+                else if (strncmp(p, "CONTROL=", 8) == 0)
+                    control_dir = t_strcut(p+8, ':');
+                p = strchr(p, ':');
+            } while (p != NULL);
+            i_info("NULL -- root dir: %s", root_dir);
+        } else {
+            /* otherwise, ':' are ok (path) */
+            root_dir = data;
+        }
 	}
 
 	if (root_dir == NULL) {
